<!doctype html>
<html lang="en">

    <head>
        <meta charset="utf-8">

        <title>Git for the Academy</title>

        <meta name="author" content="Catalyst">

        <meta name="apple-mobile-web-app-capable" content="yes" />
        <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent" />

        <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

        <link rel="stylesheet" href="css/reveal.css">
        <link rel="stylesheet" href="css/theme/catalyst.css" id="theme">

        <!-- For syntax highlighting -->
        <!-- <link rel="stylesheet" href="lib/css/zenburn.css"> -->
        <link rel="stylesheet" href="lib/css/catalyst-syntax.css">

        <!-- If the query includes 'print-pdf', include the PDF print sheet -->
        <script>
            if( window.location.search.match( /print-pdf/gi ) ) {
                var link = document.createElement( 'link' );
                link.rel = 'stylesheet';
                link.type = 'text/css';
                link.href = 'css/print/pdf.css';
                document.getElementsByTagName( 'head' )[0].appendChild( link );
            }
        </script>

        <style>
            /* Add the ability to omit slides from the printed version (has to be after the print include)*/
            @media print {
                .reveal .slides section.no-print {
                    display: none !important;
                    visibility: hidden !important;
                }
            }
            code {
              text-align: left;
              display: inline-block;
              width: 100% !important;
              padding: 8px !important;
              background-color: #26081d;
              color: white !important;
              font-size: .5em !important;
            }
            .code-type {
              font-weight: bold !important;
              font-size: .75em !important;
              background-color: #889A3A;
              color: black !important;
            }
            .code-green {
              color: #889A3A;
            }
            .code-red {
              color: #BA2025;
            }
            .code-mustard {
              color: #C6B253;
            }
            .step-overlay {
              position: absolute;
              padding-top: 10px;
              top: -2px;
              width: 100%;
              background: rgba(255, 255, 255, 0.85);
              text-align: center;
              border-bottom: 8px solid #50433C !important;
            }
            img[alt=logo] {
              width: 30%;
              padding: 2%;
            }
            img[alt=step] {
              position: relative;
              z-index: -1;
              top: -5px;
              border: 8px solid #889A3A !important;
            }
            img[alt=review] {
              border: 8px solid #50433C !important;
            }
        </style>

        <!--[if lt IE 9]>
        <script src="lib/js/html5shiv.js"></script>
        <![endif]-->

        <!-- Please put any custom styles here -->
        <style>

        </style>
    </head>

    <body>

        <div class="reveal">

            <!-- Any section element inside of this container is displayed as a slide -->
            <div class="slides">

                <!-- Cover slide -->
                <section>
                    <section data-markdown>
                        <script type="text/template">
# Catalyst <!-- .element: class="catalyst-logo" -->

### Revision Control for the Academy
Presented by <!-- .element: class="small-text" --> Julia and Evan <!-- .element: class="small-text" -->
                        </script>
                    </section>

                    <section data-markdown>
                        <script type="text/template">
## Administrivia
* Follow along as we go
* Things you should do are in <strong><span class="code-green">green</span></strong>
* If you have questions, shout!
                        </script>
                    </section>
                </section>

                <section data-markdown><!-- Guage the audience -->
                    <script type="text/template">
## Hands Up!
![](img/zebra.gif "Dancing Donkey")

Note:

 * Who has heard of Git?

 * Who has used Git?

 * Who knows who wrote Git?

   * And what else is he known for?

 * Who knows what Github is? (or Gitlab or Bitbucket or ...)

 * Who has an account on Github?

                    </script>
                </section>

                <section><!-- What is Git?? -->
                    <section data-markdown><!-- Simplified explanation -->
                        <script type="text/template">
## What?
* Git is a revision control system<!-- .element: class="fragment" -->
* What is revision control?<!-- .element: class="fragment" -->
* Revision control is like the save button for your work<!-- .element: class="fragment" -->
* ...on steriods!<!-- .element: class="fragment" -->

Note:
Git = Revision control

Revision control = hyper save
                        </script>
                    </section>

                    <section data-markdown><!-- What you can do with it -->
                        <script type="text/template">
## Why?
* Share your work<!-- .element: class="fragment" -->
* Backup your work<!-- .element: class="fragment" -->
* Lots of other features<!-- .element: class="fragment" -->
  * Recover old versions of files
  * View past changes to a file
  * Find out who made a certain change
  * And more...
                        </script>
                    </section>

                    <section data-markdown data-background="img/things-go-wrong.gif"><!-- Gif-time -->
                        <script type="text/template">
## Because sometimes...
Note:
Git can save you
                        </script>
                    </section>

                    <section data-markdown><!-- The basic principle -->
                        <script type="text/template">
## How?
* Git keeps track of an entire directory of files (a project)<!-- .element: class="fragment" -->
* It can handle any sort of file (source code, images, etc.)<!-- .element: class="fragment" -->
* You "save" your files in a commit<!-- .element: class="fragment" -->
* Then you can share your project with others<!-- .element: class="fragment" -->

Note:

In Git a "project" is also called a "repository"
                        </script>
                    </section>
                </section>

                <section><!-- First Commands -->
                    <section data-markdown>
                        <script type="text/template">
## So Let's Dive In!
![](img/boy-at-empty-pool.jpg "Empty Pool")
                        </script>
                    </section>

                    <section>
                        <div data-markdown>
## Sharing Code
#### There are lots of sites that host Git projects

![logo](img/logo-github.png)
![logo](img/logo-gitlab.svg)
![logo](img/logo-bitbucket.png)
![logo](img/logo-gogs.png)

Note:

Many projects host their code on Github.

Today, we will be using Github.

Mention alternatives, closed vs. open source.
                    </section>

                    <section><!-- Github Account Creation -->
                      <img style="width: 400px;" auto src="img/image-octocat.png"/>
                      <div data-markdown>
## Create a Github Account
                      </div>
                      <div data-markdown>
                        https://github.com/join
                      </div>
                    </section>

                    <section>
                      <div data-markdown class="step-overlay">
                        ## Step 1: Your info
                      </div>
                      <img alt="step" src="img/join1.png" style="max-width: 720px;"/>
                      <div data-markdown>
Note:

Don't use your school email
                      </div>
                    </section>

                    <section>
                      <div data-markdown class="step-overlay">
                        ## Step 2: Plan
                      </div>
                      <img alt="step" src="img/join2.png" style="max-width: 720px;"/>
                    </section>

                    <section>
                      <div data-markdown class="step-overlay" style="margin-top: -15px">
                        ## Step 3: Other info
                      </div>
                      <img alt="step" src="img/join3.png" style="max-width: 720px; margin-top: -32px;"/>
                    </section>

                    <section>
                      <div data-markdown>## Almost done...</div>
                      <img alt="step" src="img/join4.png"/>
                    </section>

                    <section>
                      <div data-markdown>## Verify your email...</div>
                      <img alt="step" src="img/join5.png"/>
                    </section>

                    <section>
                      <div data-markdown>## Start a project...</div>
                      <img alt="step" src="img/join4.png"/>
                    </section>

                    <section>
                      <div data-markdown class="step-overlay">
                        ## Set project info...
                      </div>
                      <img alt="step" src="img/create1.png"/>
                    </section>

                    <section>
                      <div data-markdown>
## Behold your new project!
                      </div>
                      <img alt="review" src="img/project1.png"/>
                    </section>

                    <section>
                      <div data-markdown>
## Connecting with SSH
                      </div>
                      <div data-markdown class="fragment">
#### Git uses SSH keys to identify you
                      </div>
                      <p class="fragment">You need to upload your public key (not your private one!)</p>
                      <div class="fragment">
                        <p>Go to your <strong>Settings</strong> page:</p>
                        <img alt="step" src="img/settings1.png"/>
                      </div>
                    </section>

                    <section>
                      <div data-markdown>
## Add an SSH key
                      </div>
                      <p>Go to <strong>SSH and GPG keys</strong> > <strong>New SSH key</strong></p>
                      <img alt="step" src="img/settings2.png"/>
                    </section>

                    <section>
                      <div data-markdown>
### Add an SSH key (cont...)
                      </div>
                      <p>Copy your public key:</p>
                      <code class="code-type">$ cat ~/.ssh/id_rsa.pub</code>
                      <code class="fragment roll-in code-feedback">
ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAACAQDQHG0Gtwnewfvnzn9MF+wUbA0nZAe+aEDSr1IS81fLfvn<br/>
X89tnMQbs/8c85frSEdkGTajPKzYOhNr+X6dUVCKY0kx7e1+jcAzWziulSsxOVrRxiyMDRwNS9wG0IWWI0f<br/>
YOV5dRM0Z7EXu/jiPvBGWM5qJSAhohlcmj9dAgNV7QEcu75Bt2zfnMwnBxqtcX+7Oy9x4cWV5e4Gdk+U/CC<br/>
xAoRF7SbsKDyUiC3SQfqnJq6f7MQGiZwHbkndEdKf5NXyUz1JjI4D/hNxwbGjNwfoC3zcIJkH2FjsM2e66A<br/>
OYgzjO1sA1ZUs0610WyDIzcVJMOeyLtcwOuubBnhA9HdPtn61fe3+s45cEaFE1KlOhFWmVOLpbwMm/mg/91<br/>
xzI2ZQ16bhVisuVtj2aPuhsGh3m31q7Vxbxwrzn6nsXjp8ICPCGYODCiD3OErEPCLXDP5JxwFhEjVupJxK7<br/>
5aws8a1/aRuyZEKVd/tuC1rplo39Lw5Eb94MiEma00gvgjXNHQNwemW4ePb4UR4hWay7URDIairWDKDt655<br/>
91Vwyz/MQdHlW8EeD1Db9Nkl61sWWkqOiBjUSK7m3en+clAhPQN98sqi7/8l25dA5tM5QK1i2jawZQ3vx87<br/>
0mtRVYCQchQy5xsQeaxz+ii1IWcxc9USZ52STJ+QyMTk+qSKw82ackEn+/P0oS4WSGU8wI0H8zpNpfLb...<br/>
                      </code>
                    </section>

                    <section>
                      <div data-markdown>
### Add an SSH key (cont...)

Paste your public key into your profile:
                      </div>
                      <img alt="step" src="img/settings3.png"/>
                      <p>(It may ask you for your password -- if so just enter it)</p>
                    </section>

                    <section>
                      <div data-markdown>
## git config
                      </div>
                      <p>Open a shell, and type...</p>
                      <div class="fragment">
                        <code class="code-type">$ git config --global user.name "my full name"</code>
                        <code class="code-type">$ git config --global user.email "your_email@example.com"</code>
                        <p>(These commands don't print anything)</p>
                      </div>
                      <div data-markdown>
Note:

Why does Git need your name and email?
                      </div>
                    </section>

                    <section><!-- Command: git clone -->
                      <div data-markdown>
                      ## git clone
                      </div>
                      <p>Run this command:</p>
                      <code class="code-type">$ git clone git@github.com:&lt;username&gt;/movie-night-vote.git</code>
                      <p>You will see something like this:</p>
                      <code class="fragment roll-in code-feedback">
                        trainer@academy ~/ $ git clone git@github.com:&lt;username&gt;/movie-night-vote.git</br>
                        Cloning into 'movie-night-vote'...</br>
                        remote: Counting objects: 3, done.</br>
                        remote: Total 3 (delta 0), reused 0 (delta 0), pack-reused 0</br>
                        Receiving objects: 100% (3/3), done.</br>
                        Checking connectivity... done.</br>
                      </code>
                      <p class="fragment roll-in code-feedback">Now move into your the project directory:</p>
                      <code class="code-type fragment roll-in code-feedback">$ cd movie-night-vote</code>
                    </section>

                    <section><!-- Command: git status -->
                      <div data-markdown>
                      ## git status
                      </div>
                      <p>Run this command:</p>
                      <code class="code-type">$ git status</code>
                      <p>To show something like this:</p>
                      <code class="fragment roll-in code-feedback">
                        trainer@academy ~/movie-night-vote $ git status</br>
                         On branch master</br>
                         Your branch is up-to-date with 'origin/master'.</br>
                         </br>
                         nothing to commit, working directory clean
                       </code>
                    </section>

                    <section><!-- Command: git diff -->
                        <div data-markdown>
                          ## git status (#2)
                        </div>
                        <p>Change a file, then check the status again</p>
                        <code class="code-type">$ vim README.md</code>
                        <code class="code-type">$ git status</code>
                        <p>Should show something like...</p>
                        <code class="code-feedback fragment roll-in">
                          trainer@academy ~/movie-night-vote $ git status</br>
                          On branch master</br>
                          Your branch is up-to-date with 'origin/master'.</br>
                          </br>
                          Changes not staged for commit:</br>
                          &nbsp;&nbsp;(use "git add &lt;file&gt;..." to update what will be committed)</br>
                          &nbsp;&nbsp;(use "git checkout -- &lt;file&gt;..." to discard changes in working directory)</br></br>
                          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span class="code-red">modified:   README.md</span></br>
                          </br>
                          no changes added to commit (use "git add" and/or "git commit -a")
                        </code>
                    </section>

                    <section><!-- Command: git diff -->
                        <div data-markdown>
                          ## git diff
                        </div>
                        <p>View the change</p>
                        <code class="code-type">$ git diff</code>
                        <p>Should show something like...</p>
                        <div class="fragment roll-in">
                          <code class="code-feedback">
                            trainer@academy ~/movie-night-vote $ git diff</br>
                            diff --git a/README.md b/README.md</br>
                            index b1a17ba..f55c2ce 100644</br>
                            --- a/README.md</br>
                            +++ b/README.md</br>
                            @@ -1 +1,2 @@</br>
                            <span class="code-red">-#movie-night-vote</span></br>
                            <span class="code-green">+My new improved readme information.</span></br>
                          </code>
                        </div>
                    </section>

                    <section><!-- Command: git add README.md -->
                      <div data-markdown>
                        ## git add
                      </div>
                      <p>Stage the changed file to be saved</p>
                      <code class="code-type">$ git add README.md</code>
                      <p>(This command returns nothing)</p>
                    </section>

                    <section><!-- Command: git diff -->
                        <div data-markdown>
                          ## git status (#3)
                        </div>
                        <code class="code-type">$ git status</code>
                        <p>Should show something like...</p>
                        <code class="code-feedback fragment roll-in">
                          trainer@academy ~/movie-night-vote $ git status</br>
                          On branch master</br>
                          Your branch is up-to-date with 'origin/master'.</br>
                          </br>
                          Changes to be committed:</br>
                          &nbsp;&nbsp;(use "git reset HEAD &lt;file&gt;..." to unstage)</br></br>
                          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span class="code-green">modified:   README.md</span>
                        </code>
                    </section>

                    <section><!-- Command: git commit -->
                      <div data-markdown>
                        ## git commit
                      </div>
                      <p>Now save (commit) the change</p>
                      <code class="code-type">$ git commit</code>
                      <p>Puts you into a text editor requesting a commit message</p>
                      <code class="code-feedback fragment roll-in">
                        <span class="code-mustard">Your commit message goes here</span></br>
                        # Please enter the commit message for your changes. Lines starting</br>
                        # with '#' will be ignored, and an empty message aborts the commit.</br>
                        # </br>
                        # Changes to be committed:</br>
                        #&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span class="code-green">modified:</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span class="code-red">README.md</span></br>
                        #
                      </code>
                      <p class="fragment roll-in">Add a commit message (a summary of your change, eg "Updated README.md.) in the top line then save and quit."</p>
                    </section>

                    <section><!-- Command: git log -->
                      <div data-markdown>
                        ## git log
                      </div>
                      <p>Now let's view our commit history (log)</p>
                      <code class="code-type">$ git log</code>
                      <p>Should show something like...</p>
                      <code class="fragment roll-in">
                      trainer@academy ~/movie-night-vote $ git log</br>
                      <span class="code-mustard">commit 93b4e770e61aaf1b0b7b20cb2b69c4a99278a664</span></br>
                      Author: Trainer &lt;trainer@catalyst.net.nz&gt;</br>
                      Date:   Wed Dec 20 01:30:52 2017 +1300</br>
                      </br>
                      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Updated README.md.</br></br>
                      <span class="code-mustard">commit cb2b69c4a99278a66493b4e770e61aaf1b0b7b20</span></br>
                      Author: Trainer&lt;trainer@catalyst.net.nz&gt;</br>
                      Date:   Wed Dec 20 01:28:52 2017 +1300</br>
                      </br>
                      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Initial commit</br>
                      </code>
                    </section>

                    <section><!-- Command: git log -->
                      <div data-markdown>
                        ## git push
                      </div>
                      <p>Now let's share our work</p>
                      <code class="code-type">$ git push</code>
                      <p>Should show something like...</p>
                      <code class="fragment roll-in">
                      trainer@academy ~/movie-night-vote $ git push</br>
                      Counting objects: 5, done.</br>
                      Writing objects: 100% (5/5), 227 bytes | 0 bytes/s, done.</br>
                      Total 3 (delta 0), reused 0 (delta 0)</br>
                      To git@github.com:Trainer/movie-night-vote.git</br>
                      &nbsp;&nbsp;c93c211..93b4e77  master -> master</br>
                      </code>
                      <p class="fragment">Go view your change on Github!</p>
                    </section>

                    <section data-markdown><!-- commands overview -->
                        <script type="text/template">
## Git Commands
* git config <span>&larr; _Set configuration values_</span><!-- .element: class="fragment" -->
* git clone <span>&larr; _Download a repository_</span><!-- .element: class="fragment" -->
* git status <span>&larr; _Get ready to save my work_</span><!-- .element: class="fragment" -->
* git diff <span>&larr; _What changes have I made?_</span><!-- .element: class="fragment" -->
* git add <span>&larr; _Get ready to save my work_</span><!-- .element: class="fragment" -->
* git commit <span>&larr; _Save 'added' work in a commit_</span><!-- .element: class="fragment" -->
* git log <span>&larr; _Show past commits_</span><!-- .element: class="fragment" -->
* git push <span>&larr; _Share my commits_</span><!-- .element: class="fragment" -->
                        </script>
                    </section>
                </section>

                <section>
                  <section>
                    <div data-markdown>
## Exercise Time!
#### Contribute to your neighbour's project:
                    </div>
                    <ol>
                      <li>Pair up.</li>
                      <li>From your project's settings page, add your neighbour as a <strong>collaborator</strong> (they will need to accept your invitation).</li>
                      <li>Accept your neighbour's invitation to collaborate.</li>
                      <li><strong>Clone</strong> your neighbour's repository.</li>
                      <li>Create a new <strong>commit</strong> and <strong>push</strong> it to your neighbour's repository.</li>
                    </ol>
                  </section>

                  <section data-markdown>
                    <script type="text/template">
## Now what?

#### Now go use Git!

All the Academy projects are hosted in Git

1. Find the coding guidelines
1. Clone the code, hack on it, commit your work
1. Submit your work...
                    </script>
                  </section>

                  <section data-markdown>
                    <script type="text/template">
## Submit how?

#### Each project is a little bit different

* _Drupal_: Attach commits to 'issues' as patches
* _Koha_: Attach commits to 'bugs' as patches
* _Silverstripe_: Pull Request via Github
* _Piwik_: Pull Request via Github
* _Moodle_: Attach commits to 'issues' as links to a branch

Note:

Explain "patches"
                    </script>
                  </section>

                  <section data-markdown>
                    <script type="text/template">
## Thanks!

Please send questions to  
<julia@catalyst.net.nz> or
<evanh@catalyst.net.nz>
                    </script>
                  </section>

                  <section data-background-image="img/big-finish.gif"/></section>
                </section>
            </div>

            <div class="footer" style="display: none;">
                <div class="scarf">
                    <div class="scarf-orange"></div>
                    <div class="scarf-yellow"></div>
                    <div class="scarf-blue"></div>
                    <div class="scarf-green"></div>
                </div>
                <div class="footer-inner">
                    <div>
                        <!-- NOTE: use only one of these. open-source-technologists is the standard -->
                        <p class="open-source-technologists">open source technologists</p>
                        <!-- <p class="freedom-to-innovate">freedom to innovate</p> -->
                    </div>
                </div>
            </div>
        </div>

        <!-- **** PRESENTATION DONE ****-->

        <script src="lib/js/head.min.js"></script>
        <script src="js/reveal.js"></script>

        <script>

            // Full list of configuration options available here:
            // https://github.com/hakimel/reveal.js#configuration
            Reveal.initialize({
                controls: true,
                progress: true,
                history: true,
                center: true,

                theme: Reveal.getQueryHash().theme, // available themes are in /css/theme
                transition: Reveal.getQueryHash().transition || 'none', // default/cube/page/concave/zoom/linear/fade/none

                // Parallax scrolling
                // parallaxBackgroundImage: 'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg',
                // parallaxBackgroundSize: '2100px 900px',

                // Optional libraries used to extend on reveal.js
                dependencies: [
                    { src: 'lib/js/classList.js', condition: function() { return !document.body.classList; } },
                    { src: 'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
                    { src: 'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
                    { src: 'plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } },
                    { src: 'plugin/zoom-js/zoom.js', async: true, condition: function() { return !!document.body.classList; } },
                    { src: 'plugin/notes/notes.js', async: true, condition: function() { return !!document.body.classList; } }
                ]
            });

        </script>
    </body>
</html>
